# Bring Powersort to Java

## Gradle

### Setup

Check which Java toolchains can be found by Gradle:

```shell
./gradlew javaToolchains
```

This should include version >= 17, e.g.:

```
 + N/A JDK 23-ga
     | Location:           /nix/store/48290hnlb13xmwjw9y16a1s785993bv7-openjdk-23-ga/lib/openjdk
     | Language Version:   23
     | Vendor:             N/A
     | Architecture:       amd64
     | Is JDK:             true
     | Detected by:        Current JVM
```

### Tasks

List all Gradle tasks which can be run:

```shell
./gradlew tasks
```

This can also be done graphically in IntelliJ:

![intellij-gradle.png](intellij-gradle.png)

### Test Cases

Run the task "test":

```shell
./gradlew test
```

## TimSort

Imported from
- src/java.base/share/classes/java/util/TimSort.java
- src/java.base/share/classes/java/util/ComparableTimSort.java
